<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `&#x2F;nix&#x2F;store&#x2F;klw0pjcx3gcsqz561gi1wwv8hj1lg84w-vendored-sources&#x2F;postcard-cobs-0.1.5-pre&#x2F;src&#x2F;enc.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>enc.rs - source</title><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../light.css"  id="themeStyle"><link rel="stylesheet" type="text/css" href="../../dark.css" disabled ><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled ><script id="default-settings" ></script><script src="../../storage.js"></script><script src="../../crates.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"><style type="text/css">#crate-search{background-image:url("../../down-arrow.svg");}</style></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="sidebar"><div class="sidebar-menu" role="button">&#9776;</div><a href='../../postcard_cobs/index.html'><div class='logo-container rust-logo'><img src='../../rust-logo.png' alt='logo'></div></a></nav><div class="theme-picker"><button id="theme-picker" aria-label="Pick another theme!" aria-haspopup="menu" title="themes"><img width="18" height="18" alt="Pick another theme!" src="../../brush.svg"></button><div id="theme-choices" role="menu"></div></div><nav class="sub"><form class="search-form"><div class="search-container"><div><select id="crate-search"><option value="All crates">All crates</option></select><input class="search-input" name="search" disabled autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"></div><button type="button" id="help-button" title="help">?</button><a id="settings-menu" href="../../settings.html" title="settings"><img width="18" height="18" alt="Change settings" src="../../wheel.svg"></a></div></form></nav><section id="main" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">  1</span>
<span id="2">  2</span>
<span id="3">  3</span>
<span id="4">  4</span>
<span id="5">  5</span>
<span id="6">  6</span>
<span id="7">  7</span>
<span id="8">  8</span>
<span id="9">  9</span>
<span id="10"> 10</span>
<span id="11"> 11</span>
<span id="12"> 12</span>
<span id="13"> 13</span>
<span id="14"> 14</span>
<span id="15"> 15</span>
<span id="16"> 16</span>
<span id="17"> 17</span>
<span id="18"> 18</span>
<span id="19"> 19</span>
<span id="20"> 20</span>
<span id="21"> 21</span>
<span id="22"> 22</span>
<span id="23"> 23</span>
<span id="24"> 24</span>
<span id="25"> 25</span>
<span id="26"> 26</span>
<span id="27"> 27</span>
<span id="28"> 28</span>
<span id="29"> 29</span>
<span id="30"> 30</span>
<span id="31"> 31</span>
<span id="32"> 32</span>
<span id="33"> 33</span>
<span id="34"> 34</span>
<span id="35"> 35</span>
<span id="36"> 36</span>
<span id="37"> 37</span>
<span id="38"> 38</span>
<span id="39"> 39</span>
<span id="40"> 40</span>
<span id="41"> 41</span>
<span id="42"> 42</span>
<span id="43"> 43</span>
<span id="44"> 44</span>
<span id="45"> 45</span>
<span id="46"> 46</span>
<span id="47"> 47</span>
<span id="48"> 48</span>
<span id="49"> 49</span>
<span id="50"> 50</span>
<span id="51"> 51</span>
<span id="52"> 52</span>
<span id="53"> 53</span>
<span id="54"> 54</span>
<span id="55"> 55</span>
<span id="56"> 56</span>
<span id="57"> 57</span>
<span id="58"> 58</span>
<span id="59"> 59</span>
<span id="60"> 60</span>
<span id="61"> 61</span>
<span id="62"> 62</span>
<span id="63"> 63</span>
<span id="64"> 64</span>
<span id="65"> 65</span>
<span id="66"> 66</span>
<span id="67"> 67</span>
<span id="68"> 68</span>
<span id="69"> 69</span>
<span id="70"> 70</span>
<span id="71"> 71</span>
<span id="72"> 72</span>
<span id="73"> 73</span>
<span id="74"> 74</span>
<span id="75"> 75</span>
<span id="76"> 76</span>
<span id="77"> 77</span>
<span id="78"> 78</span>
<span id="79"> 79</span>
<span id="80"> 80</span>
<span id="81"> 81</span>
<span id="82"> 82</span>
<span id="83"> 83</span>
<span id="84"> 84</span>
<span id="85"> 85</span>
<span id="86"> 86</span>
<span id="87"> 87</span>
<span id="88"> 88</span>
<span id="89"> 89</span>
<span id="90"> 90</span>
<span id="91"> 91</span>
<span id="92"> 92</span>
<span id="93"> 93</span>
<span id="94"> 94</span>
<span id="95"> 95</span>
<span id="96"> 96</span>
<span id="97"> 97</span>
<span id="98"> 98</span>
<span id="99"> 99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
<span id="194">194</span>
<span id="195">195</span>
<span id="196">196</span>
<span id="197">197</span>
<span id="198">198</span>
<span id="199">199</span>
<span id="200">200</span>
<span id="201">201</span>
<span id="202">202</span>
<span id="203">203</span>
<span id="204">204</span>
</pre><pre class="rust"><code><span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;use_std&quot;</span>)]</span>
<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::max_encoding_length</span>;

<span class="doccomment">/// The [`CobsEncoder`] type is used to encode a stream of bytes to a</span>
<span class="doccomment">/// given mutable output slice. This is often useful when heap data</span>
<span class="doccomment">/// structures are not available, or when not all message bytes are</span>
<span class="doccomment">/// received at a single point in time.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">CobsEncoder</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> {
    <span class="ident">dest</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="kw-2">mut</span> [<span class="ident">u8</span>],
    <span class="ident">dest_idx</span>: <span class="ident">usize</span>,
    <span class="ident">state</span>: <span class="ident">EncoderState</span>,
}

<span class="doccomment">/// The [`EncoderState`] is used to track the current state of a</span>
<span class="doccomment">/// streaming encoder. This struct does not contain the output buffer</span>
<span class="doccomment">/// (or a reference to one), and can be used when streaming the encoded</span>
<span class="doccomment">/// output to a custom data type</span>
<span class="doccomment">///</span>
<span class="doccomment">/// **IMPORTANT NOTE**: When implementing a custom streaming encoder,</span>
<span class="doccomment">/// the [`EncoderState`] state machine assumes that the output buffer</span>
<span class="doccomment">/// **ALREADY** contains a single placeholder byte, and no other bytes.</span>
<span class="doccomment">/// This placeholder byte will be later modified with the first distance</span>
<span class="doccomment">/// to the next header/zero byte.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">EncoderState</span> {
    <span class="ident">code_idx</span>: <span class="ident">usize</span>,
    <span class="ident">num_bt_sent</span>: <span class="ident">u8</span>,
    <span class="ident">offset_idx</span>: <span class="ident">u8</span>,
}

<span class="doccomment">/// [`PushResult`] is used to represent the changes to an (encoded)</span>
<span class="doccomment">/// output data buffer when an unencoded byte is pushed into [`EncoderState`].</span>
<span class="kw">pub</span> <span class="kw">enum</span> <span class="ident">PushResult</span> {
    <span class="doccomment">/// The returned byte should be placed at the current end of the data buffer</span>
    <span class="ident">AddSingle</span>(<span class="ident">u8</span>),

    <span class="doccomment">/// The byte at the given index should be replaced with the given byte.</span>
    <span class="doccomment">/// Additionally, a placeholder byte should be inserted at the current</span>
    <span class="doccomment">/// end of the output buffer to be later modified</span>
    <span class="ident">ModifyFromStartAndSkip</span>((<span class="ident">usize</span>, <span class="ident">u8</span>)),

    <span class="doccomment">/// The byte at the given index should be replaced with the given byte.</span>
    <span class="doccomment">/// Then, the last u8 in this tuple should be inserted at the end of the</span>
    <span class="doccomment">/// current output buffer. Finally, a placeholder byte should be inserted at</span>
    <span class="doccomment">/// the current end of the output buffer to be later modified</span>
    <span class="ident">ModifyFromStartAndPushAndSkip</span>((<span class="ident">usize</span>, <span class="ident">u8</span>, <span class="ident">u8</span>))
}

<span class="kw">impl</span> <span class="ident">Default</span> <span class="kw">for</span> <span class="ident">EncoderState</span> {
    <span class="doccomment">/// Create a default initial state representation for a COBS encoder</span>
    <span class="kw">fn</span> <span class="ident">default</span>() <span class="op">-</span><span class="op">&gt;</span> <span class="self">Self</span> {
        <span class="self">Self</span> {
            <span class="ident">code_idx</span>: <span class="number">0</span>,
            <span class="ident">num_bt_sent</span>: <span class="number">1</span>,
            <span class="ident">offset_idx</span>: <span class="number">1</span>,
        }
    }
}

<span class="kw">impl</span> <span class="ident">EncoderState</span> {
    <span class="doccomment">/// Push a single unencoded byte into the encoder state machine</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">push</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>, <span class="ident">data</span>: <span class="ident">u8</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">PushResult</span> {
        <span class="kw">if</span> <span class="ident">data</span> <span class="op">=</span><span class="op">=</span> <span class="number">0</span> {
            <span class="kw">let</span> <span class="ident">ret</span> <span class="op">=</span> <span class="ident">PushResult::ModifyFromStartAndSkip</span>((<span class="self">self</span>.<span class="ident">code_idx</span>, <span class="self">self</span>.<span class="ident">num_bt_sent</span>));
            <span class="self">self</span>.<span class="ident">code_idx</span> <span class="op">+</span><span class="op">=</span> <span class="ident">usize::from</span>(<span class="self">self</span>.<span class="ident">offset_idx</span>);
            <span class="self">self</span>.<span class="ident">num_bt_sent</span> <span class="op">=</span> <span class="number">1</span>;
            <span class="self">self</span>.<span class="ident">offset_idx</span> <span class="op">=</span> <span class="number">1</span>;
            <span class="ident">ret</span>
        } <span class="kw">else</span> {
            <span class="self">self</span>.<span class="ident">num_bt_sent</span> <span class="op">+</span><span class="op">=</span> <span class="number">1</span>;
            <span class="self">self</span>.<span class="ident">offset_idx</span> <span class="op">+</span><span class="op">=</span> <span class="number">1</span>;

            <span class="kw">if</span> <span class="number">0xFF</span> <span class="op">=</span><span class="op">=</span> <span class="self">self</span>.<span class="ident">num_bt_sent</span> {
                <span class="kw">let</span> <span class="ident">ret</span> <span class="op">=</span> <span class="ident">PushResult::ModifyFromStartAndPushAndSkip</span>((<span class="self">self</span>.<span class="ident">code_idx</span>, <span class="self">self</span>.<span class="ident">num_bt_sent</span>, <span class="ident">data</span>));
                <span class="self">self</span>.<span class="ident">num_bt_sent</span> <span class="op">=</span> <span class="number">1</span>;
                <span class="self">self</span>.<span class="ident">code_idx</span> <span class="op">+</span><span class="op">=</span> <span class="ident">usize::from</span>(<span class="self">self</span>.<span class="ident">offset_idx</span>);
                <span class="self">self</span>.<span class="ident">offset_idx</span> <span class="op">=</span> <span class="number">1</span>;
                <span class="ident">ret</span>
            } <span class="kw">else</span> {
                <span class="ident">PushResult::AddSingle</span>(<span class="ident">data</span>)
            }
        }
    }

    <span class="doccomment">/// Finalize the encoding process for a single message.</span>
    <span class="doccomment">/// The byte at the given index should be replaced with the given value,</span>
    <span class="doccomment">/// and the sentinel value (typically 0u8) must be inserted at the current</span>
    <span class="doccomment">/// end of the output buffer, serving as a framing byte.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">finalize</span>(<span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> (<span class="ident">usize</span>, <span class="ident">u8</span>) {
        (<span class="self">self</span>.<span class="ident">code_idx</span>, <span class="self">self</span>.<span class="ident">num_bt_sent</span>)
    }
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> <span class="ident">CobsEncoder</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> {

    <span class="doccomment">/// Create a new streaming Cobs Encoder</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">new</span>(<span class="ident">out_buf</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="kw-2">mut</span> [<span class="ident">u8</span>]) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">CobsEncoder</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> {
        <span class="ident">CobsEncoder</span> {
            <span class="ident">dest</span>: <span class="ident">out_buf</span>,
            <span class="ident">dest_idx</span>: <span class="number">1</span>,
            <span class="ident">state</span>: <span class="ident">EncoderState::default</span>(),
        }
    }

    <span class="doccomment">/// Push a slice of data to be encoded</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">push</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>, <span class="ident">data</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>]) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Result</span><span class="op">&lt;</span>(), ()<span class="op">&gt;</span> {
        <span class="comment">// TODO: could probably check if this would fit without</span>
        <span class="comment">// iterating through all data</span>
        <span class="kw">for</span> <span class="ident">x</span> <span class="kw">in</span> <span class="ident">data</span> {
            <span class="kw">use</span> <span class="ident">PushResult</span>::<span class="kw-2">*</span>;
            <span class="kw">match</span> <span class="self">self</span>.<span class="ident">state</span>.<span class="ident">push</span>(<span class="kw-2">*</span><span class="ident">x</span>) {
                <span class="ident">AddSingle</span>(<span class="ident">y</span>) <span class="op">=</span><span class="op">&gt;</span> {
                    <span class="kw-2">*</span><span class="self">self</span>.<span class="ident">dest</span>.<span class="ident">get_mut</span>(<span class="self">self</span>.<span class="ident">dest_idx</span>)
                        .<span class="ident">ok_or_else</span>(<span class="op">|</span><span class="op">|</span> ())<span class="question-mark">?</span> <span class="op">=</span> <span class="ident">y</span>;
                }
                <span class="ident">ModifyFromStartAndSkip</span>((<span class="ident">idx</span>, <span class="ident">mval</span>)) <span class="op">=</span><span class="op">&gt;</span> {
                    <span class="kw-2">*</span><span class="self">self</span>.<span class="ident">dest</span>.<span class="ident">get_mut</span>(<span class="ident">idx</span>)
                        .<span class="ident">ok_or_else</span>(<span class="op">|</span><span class="op">|</span> ())<span class="question-mark">?</span> <span class="op">=</span> <span class="ident">mval</span>;
                }
                <span class="ident">ModifyFromStartAndPushAndSkip</span>((<span class="ident">idx</span>, <span class="ident">mval</span>, <span class="ident">nval1</span>)) <span class="op">=</span><span class="op">&gt;</span> {
                    <span class="kw-2">*</span><span class="self">self</span>.<span class="ident">dest</span>.<span class="ident">get_mut</span>(<span class="ident">idx</span>)
                        .<span class="ident">ok_or_else</span>(<span class="op">|</span><span class="op">|</span> ())<span class="question-mark">?</span> <span class="op">=</span> <span class="ident">mval</span>;
                    <span class="kw-2">*</span><span class="self">self</span>.<span class="ident">dest</span>.<span class="ident">get_mut</span>(<span class="self">self</span>.<span class="ident">dest_idx</span>)
                        .<span class="ident">ok_or_else</span>(<span class="op">|</span><span class="op">|</span> ())<span class="question-mark">?</span> <span class="op">=</span> <span class="ident">nval1</span>;
                    <span class="self">self</span>.<span class="ident">dest_idx</span> <span class="op">+</span><span class="op">=</span> <span class="number">1</span>;
                }
            }

            <span class="comment">// All branches above require advancing the pointer at least once</span>
            <span class="self">self</span>.<span class="ident">dest_idx</span> <span class="op">+</span><span class="op">=</span> <span class="number">1</span>;
        }

        <span class="prelude-val">Ok</span>(())
    }

    <span class="doccomment">/// Complete encoding of the output message. Does NOT terminate</span>
    <span class="doccomment">/// the message with the sentinel value</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">finalize</span>(<span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">usize</span>, ()<span class="op">&gt;</span> {
        <span class="kw">if</span> <span class="self">self</span>.<span class="ident">dest_idx</span> <span class="op">=</span><span class="op">=</span> <span class="number">1</span> {
            <span class="kw">return</span> <span class="prelude-val">Ok</span>(<span class="number">0</span>);
        }

        <span class="comment">// Get the last index that needs to be fixed</span>
        <span class="kw">let</span> (<span class="ident">idx</span>, <span class="ident">mval</span>) <span class="op">=</span> <span class="self">self</span>.<span class="ident">state</span>.<span class="ident">finalize</span>();

        <span class="comment">// If the current code index is outside of the destination slice,</span>
        <span class="comment">// we do not need to write it out</span>
        <span class="kw">if</span> <span class="kw">let</span> <span class="prelude-val">Some</span>(<span class="ident">i</span>) <span class="op">=</span> <span class="self">self</span>.<span class="ident">dest</span>.<span class="ident">get_mut</span>(<span class="ident">idx</span>) {
            <span class="kw-2">*</span><span class="ident">i</span> <span class="op">=</span> <span class="ident">mval</span>;
        }

        <span class="kw">return</span> <span class="prelude-val">Ok</span>(<span class="self">self</span>.<span class="ident">dest_idx</span>);
    }
}

<span class="doccomment">/// Encodes the `source` buffer into the `dest` buffer.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This function uses the typical sentinel value of 0. It returns the number of bytes</span>
<span class="doccomment">/// written to in the `dest` buffer.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # Panics</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This function will panic if the `dest` buffer is not large enough for the</span>
<span class="doccomment">/// encoded message. You can calculate the size the `dest` buffer needs to be with</span>
<span class="doccomment">/// the `max_encoding_length` function.</span>
<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">encode</span>(<span class="ident">source</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>], <span class="ident">dest</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span>[<span class="ident">u8</span>]) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">usize</span> {
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">enc</span> <span class="op">=</span> <span class="ident">CobsEncoder::new</span>(<span class="ident">dest</span>);
    <span class="ident">enc</span>.<span class="ident">push</span>(<span class="ident">source</span>).<span class="ident">unwrap</span>();
    <span class="ident">enc</span>.<span class="ident">finalize</span>().<span class="ident">unwrap</span>()
}

<span class="doccomment">/// Encodes the `source` buffer into the `dest` buffer using an</span>
<span class="doccomment">/// arbitrary sentinel value.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This is done by first encoding the message with the typical sentinel value</span>
<span class="doccomment">/// of 0, then XOR-ing each byte of the encoded message with the chosen sentinel</span>
<span class="doccomment">/// value. This will ensure that the sentinel value doesn&#39;t show up in the encoded</span>
<span class="doccomment">/// message. See the paper &quot;Consistent Overhead Byte Stuffing&quot; for details.</span>
<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">encode_with_sentinel</span>(<span class="ident">source</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>], <span class="ident">dest</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span>[<span class="ident">u8</span>], <span class="ident">sentinel</span>: <span class="ident">u8</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">usize</span> {
    <span class="kw">let</span> <span class="ident">encoded_size</span> <span class="op">=</span> <span class="ident">encode</span>(<span class="ident">source</span>, <span class="ident">dest</span>);
    <span class="kw">for</span> <span class="ident">x</span> <span class="kw">in</span> <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">dest</span>[..<span class="ident">encoded_size</span>] {
        <span class="kw-2">*</span><span class="ident">x</span> <span class="op">^</span><span class="op">=</span> <span class="ident">sentinel</span>;
    }
    <span class="kw">return</span> <span class="ident">encoded_size</span>;
}

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;use_std&quot;</span>)]</span>
<span class="doccomment">/// Encodes the `source` buffer into a vector.</span>
<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">encode_vec</span>(<span class="ident">source</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>]) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">u8</span><span class="op">&gt;</span> {
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">encoded</span> <span class="op">=</span> <span class="macro">vec!</span>[<span class="number">0</span>; <span class="ident">max_encoding_length</span>(<span class="ident">source</span>.<span class="ident">len</span>())];
    <span class="kw">let</span> <span class="ident">encoded_len</span> <span class="op">=</span> <span class="ident">encode</span>(<span class="ident">source</span>, <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">encoded</span>[..]);
    <span class="ident">encoded</span>.<span class="ident">truncate</span>(<span class="ident">encoded_len</span>);
    <span class="kw">return</span> <span class="ident">encoded</span>;
}

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;use_std&quot;</span>)]</span>
<span class="doccomment">/// Encodes the `source` buffer into a vector with an arbitrary sentinel value.</span>
<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">encode_vec_with_sentinel</span>(<span class="ident">source</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>], <span class="ident">sentinel</span>: <span class="ident">u8</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">u8</span><span class="op">&gt;</span> {
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">encoded</span> <span class="op">=</span> <span class="macro">vec!</span>[<span class="number">0</span>; <span class="ident">max_encoding_length</span>(<span class="ident">source</span>.<span class="ident">len</span>())];
    <span class="kw">let</span> <span class="ident">encoded_len</span> <span class="op">=</span> <span class="ident">encode_with_sentinel</span>(<span class="ident">source</span>, <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">encoded</span>[..], <span class="ident">sentinel</span>);
    <span class="ident">encoded</span>.<span class="ident">truncate</span>(<span class="ident">encoded_len</span>);
    <span class="kw">return</span> <span class="ident">encoded</span>;
}
</code></pre></div>
</section><section id="search" class="content hidden"></section><div id="rustdoc-vars" data-root-path="../../" data-current-crate="postcard_cobs" data-search-index-js="../../search-index.js" data-search-js="../../search.js"></div>
    <script src="../../main.js"></script><script src="../../source-script.js"></script><script src="../../source-files.js"></script>
</body></html>